BUBBLE_PROX_N = 100.0 ;

function wait( seconds )
	local count = 0.0 ;
	while ( count < seconds ) do
		--DEBUG_OUTPUT( "Count: " .. count ) ;
		coroutine.yield( ) ;
		count = count + getDeltaT( ) ;
	end
end

function printiv( i, v )
	if ( ( type( v ) == "number" )
		or ( type( v ) == "string" ) ) then
		DEBUG_OUTPUT( i .. "=" .. v ) ;
	elseif ( type( v ) == "boolean" ) then
		-- can't concatenate boolean - so do it seperate
		local displayValue = "false" ;
		if ( v ) then
			displayValue = "true" ;
		end
		DEBUG_OUTPUT( i .. "=" .. displayValue ) ;
	end
end

function printAllGlobals( )
	DEBUG_OUTPUT( "\n---Globals Start---" ) ;
	table.foreach( _G, printiv ) ;
	DEBUG_OUTPUT( "---Globals End---\n" ) ;
end

function controlToString( controlString )
	if ( controlString == "mouse" ) then
		return getString( "mousecontrol" ) ;
	elseif ( controlString == "arrows" ) then
		return getString( "arrowcontrol" ) ;
	elseif ( controlString == "asdf" ) then
		return getString( "asdfcontrol" ) ;
	else
		return "other" ;
	end
end

function howToMoveTip( )
	if ( not isFirstWorldVersion( ) ) then
		return
	end

	clearTipVars( ) ;
	setTipTitle( getString( "howtomovetitle" ) ) ;
	if ( isIOS( ) ) then
		if ( getNumPlayers( ) == 1 ) then
			if ( getEffectiveControlMethod( ) == "accelerometer" ) then
				setTipText( getString( "howtomovetilt" ) ) ;
			elseif ( getEffectiveControlMethod( ) == "touch" ) then
				setTipText( getString( "howtomoveiostouch" ) ) ;
				setTipImage( "tap" ) ;
			elseif ( getEffectiveControlMethod( ) == "joystick" ) then
				setTipText( getString( "howtomovevirtualjoystick" ) ) ;
				setTipImage( "virtualjoystickmove" ) ;
			elseif ( getEffectiveControlMethod( ) == "physicaljoystick" ) then
				setTipText( getString( "howtomovephysicaljoystick" ) ) ;
			elseif ( getEffectiveControlMethod( ) == "trackpad" ) then
				setTipText( getString( "howtomovetrackpad" ) ) ;
			end
		else
			setTipText( getString( "tiptwoplayer" ) ) ;
			setTipImage( "tap" ) ;
		end
	else
		if ( getNumPlayers( ) == 1 ) then
			if ( getEffectiveControlMethod( ) == "touch" ) then
				setTipText( getString( "howtomovedownloadabletap" ) ) ;
			else
				-- normal mouse/keyboard
				setTipText( getString( "howtomovetipcontroller" ) ) ;
				setTipImage( "mousearrows" ) ;
			end
		else
			setTipText( getString( "howtomovemultitip" ) ) ;
			setTipImage( "mousearrows" ) ;
		end
	end
	activateTipWindow( ) ;
end

function boostTip( )
	if ( not isFirstWorldVersion( ) ) then
		return
	end

	clearTipVars( ) ;
	if ( isIOS( ) ) then
		if ( getNumPlayers( ) == 1 ) then
			if ( getEffectiveControlMethod( ) == "accelerometer" ) then
				setTipText( getString( "tiltboosttip" ) ) ;
				setTipImage( "tap" ) ;
				activateTipWindow( ) ;
			elseif ( getEffectiveControlMethod( ) == "joystick" ) then
				setTipText( getString( "virtualjoystickboosttip" ) ) ;
				setTipImage( "virtualjoystickboost" ) ;
				activateTipWindow( ) ;
			elseif ( getEffectiveControlMethod( ) == "physicaljoystick" ) then
				setTipText( getString( "physicaljoystickboosttip" ) ) ;
				activateTipWindow( ) ;
			end
		end
	else
		setTipImage( "boosttip" ) ;
		if ( getNumPlayers( ) == 1 ) then
			if ( not ( getEffectiveControlMethod( ) == "touch" ) ) then
				if ( getLastLevelUsingKeyboardTime( ) >= getLastLevelUsingMouseTime( ) and getLastLevelUsingKeyboardTime( ) >= getLastLevelUsingGamepadTime( ) ) then
					-- keyboard
					setTipText( getString( "keyboardboosttip" ) ) ;
					setTipImage( "keyboard" ) ;
					activateTipWindow( ) ;
				elseif ( getLastLevelUsingMouseTime( ) >= getLastLevelUsingGamepadTime( ) ) then
					-- mouse
					setTipText( getString( "mouseboosttip" ) ) ;
					activateTipWindow( ) ;
				else
					-- joypad
					setTipText( getString( "joypadboosttip" ) ) ;
					activateTipWindow( ) ;
				end
			end
		else
			-- 2 player
			setTipText( getString( "boostmultitip" ) ) ;
			activateTipWindow( ) ;
		end
	end
end

function boostTipLaterInGame( )
	clearTipVars( ) ;
	labelExtraText = "" ;
	if ( isUnderwaterLevel( ) ) then
		labelExtraText = "water" ;
	end
	
	setTipImage( "boosttip" ) ;
	if ( isIOS( ) ) then
		if ( getNumPlayers( ) == 1 ) then
			if ( getEffectiveControlMethod( ) == "accelerometer" ) then
				setTipText( getString( "tiltboosttip" .. labelExtraText ) ) ;
				activateTipWindow( ) ;
			elseif ( getEffectiveControlMethod( ) == "joystick" ) then
				setTipText( getString( "virtualjoystickboosttip" .. labelExtraText ) ) ;
				activateTipWindow( ) ;
			elseif ( getEffectiveControlMethod( ) == "physicaljoystick" ) then
				setTipText( getString( "physicaljoystickboosttip" .. labelExtraText ) ) ;
				activateTipWindow( ) ;
			end
		end
	else
		if ( getNumPlayers( ) == 1 ) then
			if ( not ( getEffectiveControlMethod( ) == "touch" ) ) then
				if ( getLastLevelUsingKeyboardTime( ) >= getLastLevelUsingMouseTime( ) and getLastLevelUsingKeyboardTime( ) >= getLastLevelUsingGamepadTime( ) ) then
					-- keyboard
					setTipText( getString( "keyboardboosttip" .. labelExtraText ) ) ;
					activateTipWindow( ) ;
				elseif ( getLastLevelUsingMouseTime( ) >= getLastLevelUsingGamepadTime( ) ) then
					-- mouse
					setTipText( getString( "mouseboosttip" .. labelExtraText ) ) ;
					activateTipWindow( ) ;
				else
					-- joypad
					setTipText( getString( "joypadboosttip" .. labelExtraText ) ) ;
					activateTipWindow( ) ;
				end
			end
		else
			-- 2 player
			setTipText( getString( "boostmultitip" .. labelExtraText ) ) ;
			activateTipWindow( ) ;
		end
	end
end

function helperArrowTip( )
	if ( not isFirstWorldVersion( ) ) then
		return
	end

	clearTipVars( ) ;
	setTipTitle( getString( "helperarrowtiptitle" ) ) ;
	setTipText( getString( "helperarrowtip" ) ) ;
	setTipImage( "helperarrowtip" ) ;
	activateTipWindow( ) ;
end







function avoidBeesTip( )
	clearTipVars( ) ;
	setTipText( getString( "avoidbeestip" ) ) ;
	tipAddEatEntity( "nectar_static", 0.5 ) ;
	tipAddDontEatEntity( "beenpc_avoidbees1_1" ) ;
	activateTipWindow( ) ;
end

function polinateSelectionTip( )
	clearTipVars( ) ;
	setTipText( getString( "polinateselectiontip" ) ) ;
	tipAddEatEntity( "petunia_static", 0.8, 0.99, 0.96, 0.1, 1.0 ) ;
	tipAddDontEatEntity( "petunia_static", 0.8, 0.56, 0.074, 0.69, 1.0 ) ;
	activateTipWindow( ) ;
end

function redBalloonsTip( )
	clearTipVars( ) ;
	setTipText( getString( "redballoonstip" ) ) ;
	activateTipWindow( ) ;
end

function soccer1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "soccer1tip" ) ) ;
	activateTipWindow( ) ;
end

function soccer2Tip( )
	clearTipVars( ) ;
	setTipText( getString( "soccer2tip" ) ) ;
	activateTipWindow( ) ;
end

function towels1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "towels1tip" ) ) ;
	activateTipWindow( ) ;
end

function bolts1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "bolts1tip" ) ) ;
	tipAddEatEntity( "nut_base", 0.5 ) ;
	tipAddEatEntity( "bolt_base", 0.5 ) ;
	tipAddDontEatEntity( "nut_base", 0.4 ) ;
	tipAddDontEatEntity( "bolt_base", 0.4 ) ;
	tipAddDontEatEntity( "nut_base", 0.6 ) ;
	tipAddDontEatEntity( "bolt_base", 0.6 ) ;
	tipAddDontEatEntity( "nut_base", 0.8 ) ;
	tipAddDontEatEntity( "bolt_base", 0.8 ) ;
	activateTipWindow( ) ;
end

function cyanide1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "cyanide1tip" ) ) ;
	tipAddEatEntity( "hcn_opaque", 0.85 ) ;
	tipAddDontEatEntity( "h2o_opaque", 0.85 ) ;
	activateTipWindow( ) ;
end

function garbageSort1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "garbagesort1tip" ) ) ;
	tipAddEatEntity( "plasticspoon_static", 0.85 ) ;
	tipAddEatEntity( "beerbottle_static", 0.85 ) ;
	tipAddEatEntity( "swimsuit_garbagesort1_1", 0.85 ) ;
	tipAddDontEatEntity( "wrasse_base", 0.85 ) ;
	tipAddDontEatEntity( "rainbowparrotfish_base", 0.85 ) ;
	activateTipWindow( ) ;
end

function bleached1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "bleached1tip" ) ) ;
	tipAddEatEntity( "lionfish_base", 0.85 ) ;
	tipAddEatEntity( "beerbottle_static", 0.85 ) ;
	tipAddEatEntity( "popcan_static", 0.85 ) ;
	tipAddEatEntity( "elkhorncoral_dead_base", 0.85 ) ;
	tipAddEatEntity( "boulderstarcoral_dead_base", 0.85 ) ;
	tipAddDontEatEntity( "wrasse_base", 0.85 ) ;
	tipAddDontEatEntity( "rainbowparrotfish_base", 0.85 ) ;
	tipAddDontEatEntity( "elkhorncoral_bleached_base", 0.85 ) ;
	tipAddDontEatEntity( "boulderstarcoral_bleached_base", 0.85 ) ;
	tipAddDontEatEntity( "elkhorncoral_healthy_base", 0.85 ) ;
	tipAddDontEatEntity( "boulderstarcoral_healthy_base", 0.85 ) ;
	activateTipWindow( ) ;
end

function bleached2Tip( )
	clearTipVars( ) ;
	setTipText( getString( "bleached2tip" ) ) ;
	tipAddEatEntity( "elkhorncoral_dead_base", 0.85 ) ;
	tipAddEatEntity( "boulderstarcoral_dead_base", 0.85 ) ;
	tipAddDontEatEntity( "elkhorncoral_bleached_base", 0.85 ) ;
	tipAddDontEatEntity( "boulderstarcoral_bleached_base", 0.85 ) ;
	tipAddDontEatEntity( "elkhorncoral_healthy_base", 0.85 ) ;
	tipAddDontEatEntity( "boulderstarcoral_healthy_base", 0.85 ) ;
	activateTipWindow( ) ;
end

function recycling1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "recycling1tip" ) ) ;
	tipAddEatEntity( "beerbottle_static", 0.85 ) ;
	tipAddEatEntity( "popcan_static", 0.85 ) ;
	tipAddDontEatEntity( "wrasse_base", 0.85 ) ;
	tipAddDontEatEntity( "plasticspoon_static", 0.85 ) ;
	tipAddDontEatEntity( "plasticknife_static", 0.85 ) ;
	tipAddDontEatEntity( "golfball_static", 0.8 ) ;
	tipAddDontEatEntity( "bottlecap_static", 0.8 ) ;
	tipAddDontEatEntity( "straw_static", 0.85 ) ;
	activateTipWindow( ) ;
end

function oil1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "oil1tip" ) ) ;
	activateTipWindow( ) ;
end

function oil2Tip( )
	clearTipVars( ) ;
	setTipText( getString( "oil2tip" ) ) ;
	tipAddEatEntity( "mallard_oil2_1oil", 0.85 ) ;
	tipAddEatEntity( "canadagoose_oil1_1oil", 0.85 ) ;
	tipAddDontEatEntity( "mallard_oil2_1clean", 0.85 ) ;
	tipAddDontEatEntity( "canadagoose_oil1_1clean", 0.85 ) ;
	activateTipWindow( ) ;
end

function oil3Tip( )
	clearTipVars( ) ;
	setTipText( getString( "oil3tip" ) ) ;
	tipAddEatEntity( "mallard_oil2_1oil", 0.85 ) ;
	tipAddEatEntity( "canadagoose_oil1_1oil", 0.85 ) ;
	tipAddEatEntity( "seaotterback_oil3_1oil", 0.85 ) ;
	tipAddEatEntity( "quillbackrockfish_oil3_1oil", 0.85 ) ;
	tipAddEatEntity( "salmon_oil3_1oil", 0.85 ) ;
	tipAddDontEatEntity( "mallard_oil2_1clean", 0.85 ) ;
	tipAddDontEatEntity( "canadagoose_oil1_1clean", 0.85 ) ;
	tipAddDontEatEntity( "seaotterback_oil3_1clean", 0.85 ) ;
	tipAddDontEatEntity( "quillbackrockfish_oil3_1clean", 0.85 ) ;
	tipAddDontEatEntity( "salmon_oil3_1clean", 0.85 ) ;
	activateTipWindow( ) ;
end

function oil4Tip( )
	clearTipVars( ) ;
	setTipText( getString( "oil4tip" ) ) ;
	activateTipWindow( ) ;
end

function oil6Tip( )
	clearTipVars( ) ;
	setTipText( getString( "oil6tip" ) ) ;
	activateTipWindow( ) ;
end

function clumsycat1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "clumsycat1tip" ) ) ;
	activateTipWindow( ) ;
end

function clumsycat2Tip( )
	clearTipVars( ) ;
	setTipText( getString( "clumsycat2tip" ) ) ;
	activateTipWindow( ) ;
end

function awning1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "awning1tip" ) ) ;
	tipAddEatEntity( "awning_base", 0.85, 0.6, 0.13, 0.13, 1.0) ;
	tipAddDontEatEntity( "awning_base", 0.85, 1.0, 1.0, 1.0, 1.0 ) ;
	tipAddDontEatEntity( "awning_base", 0.85, 0.98, 0.95, 0.29, 1.0 ) ;
	tipAddDontEatEntity( "awning_base", 0.85, 0.525, 0.66, 0.96, 1.0 ) ;
	tipAddDontEatEntity( "awning_base", 0.85, 0.518, 0.92, 0.3, 1.0 ) ;
	activateTipWindow( ) ;
end

function macaron1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "macaron1tip" ) ) ;
	tipAddEatEntity( "macaroon_base", 0.65, 0.611, 0.439, 0.07, 1.0 ) ;
	tipAddDontEatEntity( "macaroon_base", 0.65, 1.0, 0.53, 0.53, 1.0 ) ;
	tipAddDontEatEntity( "macaroon_base", 0.65, 0.47, 0.73, 0.96, 1.0 ) ;
	tipAddDontEatEntity( "macaroon_base", 0.65, 0.57, 0.88, 0.58, 1.0 ) ;
	activateTipWindow( ) ;
end

function zombies1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "zombies1tip" ) ) ;
	tipAddEatEntity( "zombie_zombies1_1", 0.8 ) ;
	tipAddDontEatEntity( "parisian_zombies1_1", 0.9 ) ;
	tipAddDontEatEntity( "policeofficergun_zombies1_1", 0.9 ) ;
	activateTipWindow( ) ;
end

function elephantmines1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "elephantmines1tip" ) ) ;
	activateTipWindow( ) ;
end

function elephantmines2Tip( )
	clearTipVars( ) ;
	setTipText( getString( "elephantmines2tip" ) ) ;
	activateTipWindow( ) ;
end

function mines1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "mines1tip" ) ) ;
	activateTipWindow( ) ;
end

function mines2Tip( )
	clearTipVars( ) ;
	setTipText( getString( "mines2tip" ) ) ;
	activateTipWindow( ) ;
end

function dungsoccer1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "dungsoccer1tip" ) ) ;
	activateTipWindow( ) ;
end

function dungsoccer2Tip( )
	clearTipVars( ) ;
	setTipText( getString( "dungsoccer2tip" ) ) ;
	activateTipWindow( ) ;
end

function native1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "native1tip" ) ) ;
	tipAddEatEntity( "feraldonkey_base", 0.85 ) ;
	tipAddEatEntity( "feralgoat_base", 0.85 ) ;
	tipAddEatEntity( "rabbit_base", 0.85 ) ;
	tipAddDontEatEntity( "platypus_base", 0.85 ) ;
	tipAddDontEatEntity( "koala_base", 0.85 ) ;
	tipAddDontEatEntity( "wombat_base", 0.85 ) ;
	activateTipWindow( ) ;
end

function farm2Tip( )
	clearTipVars( ) ;
	setTipText( getString( "farm2tip" ) ) ;
	activateTipWindow( ) ;
end

function protectbush1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "protectbush1tip" ) ) ;
	tipAddEatEntity( "feralgoat_base", 0.85 ) ;
	tipAddDontEatEntity( "turpentinebush_base", 0.85 ) ;
	activateTipWindow( ) ;
end

function brickstack2Tip( )
	clearTipVars( ) ;
	setTipText( getString( "brickstack2tip" ) ) ;
	activateTipWindow( ) ;
end

function brickstack3Tip( )
	clearTipVars( ) ;
	setTipText( getString( "brickstack3tip" ) ) ;
	activateTipWindow( ) ;
end

function pushgarbage1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "pushgarbage1tip" ) ) ;
	activateTipWindow( ) ;
end

function aircon1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "aircon1tip" ) ) ;
	tipAddEatEntity( "aircon_on_aircon1_1", 0.85 ) ;
	tipAddDontEatEntity( "aircon_off_aircon1_1", 0.85 ) ;
	activateTipWindow( ) ;
end

function windturbines1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "windturbines1tip" ) ) ;
	tipAddEatEntity( "smogburst_windturbines1_1", 0.85 ) ;
	tipAddDontEatEntity( "windturbine_windturbines1_1", 1.0 ) ;
	activateTipWindow( ) ;
end

function lionfish1Tip( )
	clearTipVars( ) ;
	setTipText( getString( "lionfish1tip" ) ) ;
	tipAddEatEntity( "lionfish_base", 0.85 ) ;
	tipAddDontEatEntity( "wrasse_base", 0.85 ) ;
	tipAddDontEatEntity( "rainbowparrotfish_base", 0.85 ) ;
	activateTipWindow( ) ;
end